"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
(function () {
    /* %CONFIG */
    // Will be replaced at run-time
    /** @type {PluginConfiguration} */
    var config = {};
    /* CONFIG% */
    if (!XMLHttpRequest.prototype._realOpen) {
        XMLHttpRequest.prototype._realOpen = XMLHttpRequest.prototype.open;
        XMLHttpRequest.prototype.open = function (method, url, async, user, password) {
            // Parse the URL, using the document's base URI if using a relative URL
            var parsedURL = new URL(url, document.baseURI);
            var originalHost = parsedURL.host;
            // If any of the targeted hosts contains the request's host
            var shouldRedirect = config.hosts.some(function (host) { return originalHost.toUpperCase().includes(host); });
            if (shouldRedirect) {
                parsedURL.protocol = "https";
                parsedURL.host = "localhost:" + config.port;
                url = parsedURL.toString();
            }
            this._realOpen(method, url, async, user, password);
            if (shouldRedirect) {
                this.setRequestHeader("x-mockfx-run-id" /* RUN_ID */, config.runId);
                this.setRequestHeader("x-mockfx-test-id" /* TEST_ID */, config.testId);
                this.setRequestHeader("x-mockfx-original-host" /* ORIGINAL_HOST */, originalHost);
                this.setRequestHeader("x-mockfx-source" /* SOURCE */, "portal");
            }
        };
    }
})();
//# sourceMappingURL=plugin.js.map