"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Target = void 0;
var __1 = require("..");
var logger_1 = require("../logger");
var Target = /** @class */ (function () {
    function Target(definition, context) {
        this.requests = [];
        this.definition = definition;
        this.context = context;
    }
    Target.prototype.getDefinition = function () {
        return this.definition;
    };
    Target.prototype.handleRequest = function (proxySend, req, res, next) {
        return __awaiter(this, void 0, void 0, function () {
            var source, originalHost, _a, unmatchedRequests, matchedRequest, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 5, , 6]);
                        source = req.headers["x-mockfx-source" /* SOURCE */];
                        originalHost = req.headers["x-mockfx-original-host" /* ORIGINAL_HOST */];
                        if (!(this.context.mode === "replay" /* Replay */)) return [3 /*break*/, 4];
                        if (!this.definition.onBeforeRequestMatch) return [3 /*break*/, 2];
                        _a = this;
                        return [4 /*yield*/, this.definition.onBeforeRequestMatch(req, this.context, this.requests)];
                    case 1:
                        _a.requests = _b.sent();
                        _b.label = 2;
                    case 2:
                        unmatchedRequests = this.requests.filter(function (request) { return !request.matched; });
                        return [4 /*yield*/, this.definition.matchRequest(req, unmatchedRequests)];
                    case 3:
                        matchedRequest = (_b.sent());
                        if (matchedRequest) {
                            matchedRequest.matched = true;
                            logger_1.logger.telemetry({
                                context: this.context,
                                source: source,
                                target: this.definition.name,
                                originalHost: originalHost,
                                time: new Date().toISOString(),
                                url: matchedRequest.url,
                                method: matchedRequest.method,
                                isMatch: true,
                                matchIndex: 0,
                                responseSizeInBytes: matchedRequest.responseSize
                            });
                            return [2 /*return*/, res
                                    .status(matchedRequest.responseCode)
                                    .set(matchedRequest.responseHeaders)
                                    .send(matchedRequest.response)];
                        }
                        _b.label = 4;
                    case 4:
                        if (this.context.mode === "record" /* Record */ || this.context.proxyUnmatched) {
                            return [2 /*return*/, proxySend(req, res)];
                        }
                        logger_1.logger.telemetry({
                            context: this.context,
                            source: source,
                            target: this.definition.name,
                            originalHost: originalHost,
                            time: new Date().toISOString(),
                            url: req.originalUrl,
                            method: req.method,
                            isMatch: false,
                            matchIndex: -1,
                            responseSizeInBytes: 0
                        });
                        next(new Error("Unable to handle request."));
                        return [3 /*break*/, 6];
                    case 5:
                        error_1 = _b.sent();
                        next(error_1);
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    Target.prototype.handleProxyResponse = function (request, mockRequest) {
        return __awaiter(this, void 0, void 0, function () {
            var source, originalHost;
            return __generator(this, function (_a) {
                source = request.headers["x-mockfx-source" /* SOURCE */];
                originalHost = request.headers["x-mockfx-original-host" /* ORIGINAL_HOST */];
                logger_1.logger.telemetry({
                    context: this.context,
                    source: source,
                    target: this.definition.name,
                    originalHost: originalHost,
                    time: new Date().toISOString(),
                    url: request.url,
                    method: request.method,
                    isMatch: false,
                    matchIndex: -1,
                    responseSizeInBytes: mockRequest.responseSize
                });
                if (this.context.mode === "record" /* Record */) {
                    mockRequest.stage = this.context.currentStage;
                    this.requests.push(mockRequest);
                }
                return [2 /*return*/];
            });
        });
    };
    Target.prototype.snapToStage = function (stage) {
        return __awaiter(this, void 0, void 0, function () {
            var stageIndex;
            return __generator(this, function (_a) {
                stageIndex = this.requests.findIndex(function (request) { return request.stage === stage; });
                if (stageIndex === -1) {
                    logger_1.logger.debug("Stage \"" + stage + "\" not found in requests.");
                    return [2 /*return*/];
                }
                this.requests = this.requests.slice(stageIndex);
                return [2 /*return*/];
            });
        });
    };
    Target.prototype.removeStage = function (stage) {
        return __awaiter(this, void 0, void 0, function () {
            var stageIndex;
            return __generator(this, function (_a) {
                stageIndex = this.requests.findIndex(function (request) { return request.stage === stage; });
                if (stageIndex === -1) {
                    logger_1.logger.debug("Stage \"" + stage + "\" not found in requests.");
                    return [2 /*return*/];
                }
                this.requests = this.requests.slice(stageIndex).filter(function (request) { return request.stage !== stage; });
                return [2 /*return*/];
            });
        });
    };
    Target.prototype.loadRequests = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this.definition.loadRequests(this.context)];
                    case 1:
                        _a.requests = _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Target.prototype.storeRequests = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                // Remove internal properties
                this.requests.forEach(function (request) {
                    delete request.matched;
                });
                return [2 /*return*/, this.definition.storeRequests(this.context, this.requests)];
            });
        });
    };
    return Target;
}());
exports.Target = Target;
//# sourceMappingURL=index.js.map